% get the the alpha channel for all blocks in an image
function getAlpha_Image(fn_img)

dir = './alpha/';
addpath('./spectralMattingCode/');
nb_alpha = 2;
img_blur = imread(['./' fn_img '.png']);
    
winsz           = 30; 
border          = 10; 
    
[h w c] = size(img_blur);
for startx = 1:winsz:w-border
    for starty = 1:winsz:h-border
        % parameters of the valid region of the current block
        valid_y = [starty, min(h,starty+winsz-1)];
        valid_h = valid_y(2)+1-valid_y(1);
        valid_x = [startx, min(w,startx+winsz-1)];
        valid_w = valid_x(2)+1-valid_x(1);
        % parameters of the entire current block
        entire_y = [max(starty-border,1), min(h, valid_y(2)+border)];
        entire_h = entire_y(2)+1-entire_y(1);
        entire_x = [max(startx-border,1), min(w, valid_x(2)+border)];
        entire_w = entire_x(2)+1-entire_x(1);

        patch = img_blur(entire_y(1):entire_y(2), entire_x(1):entire_x(2),:);
        size(patch)

        [alpha_comps, alpha] = getAlpha(dir, patch, nb_alpha);

        %figure(10); imshow(patch);
        for idx = 1:size(alpha_comps, 2)
            all_alpha{ceil((starty-1)/winsz)+1}{ceil((startx-1)/winsz)+1}{idx} ...
                = reshape(squeeze(alpha_comps(:,idx)), entire_h, entire_w);
            % figure(10+idx); imshow(reshape(squeeze(alpha_comps(:,idx)), entire_h, entire_w))
        end
    end
end
fn = sprintf('./alpha/all_alpha_%s', fn_img);
save(fn, 'all_alpha');